(function (parentObject) {
    if (parentObject.dialogs)
        return;

    ////////////////////////////////////////////////
    // Создаем общий интерфейс для создания диалога
    ////////////////////////////////////////////////
    parentObject.dialogs = {
        form: function (_class, _innerHtml, _dialogOptions) {
            var dialog = {},
				/* уникальный класс для возможности по селектору найти нужное окно */
                className = 'custom-dialog-' + Math.round(Math.random() * 100000),
				/* объединяем дефолтные параметры с пользовательскими _dialogOptions */
                dialogOptions = $.extend(true, {
                    autoOpen: false,
                    modal: true,
                    height: 150,
                    width: 400,
                    resizable: false
                }, _dialogOptions || {}),
				/* диалог, в котором будет создано всплывающее окно */
                dialogHtml = $('<div/>');

			/* добавляем div в тело документа */
            $('body').append(dialogHtml);
			/* присваиваем уникальный класс */
            dialog.uniqClassName = className;
			/* добавляем уникальный класс */
            dialogHtml.addClass(className);
			
			/* создаем всплывающее окно */
            dialog.jDialog = $(dialogHtml).dialog(dialogOptions);

			/* если задан пользовательский класс, то добавляем в общее окно */
            if (_class)
                dialog.jDialog.addClass(_class);

			/* Удаляем стандартную шапку класса */
            dialog.jDialog.parent().find('.ui-dialog-titlebar').remove();

			/* заполняем содержимое html шаблоном окна */
            dialog.jDialog.append(_innerHtml);

            return dialog;
        }
	}
	
	// Формируем диалоги 
    $(document).ready(function () {
        ////////////////////////////////////////////////
        // Окно ошибки
        ////////////////////////////////////////////////

		/* Создаем окно для вывода ошибок */
        parentObject.dialogs.error
			= parentObject.dialogs
				.form('custom-dialog-error',
					'<div class="custom-dialog-error-container">' +
						'<div class="custom-dialog-error-container-title">' +
						'</div>' +
						'<div class="custom-dialog-error-container-text">' +
						'</div>' +
						'<div class="custom-dialog-error-container-btn-container">' +
							'<button type="button" class="custom-button-cancel">Закрыть</button>' +
						'</div>' +
					'</div>', {
						height: 220
					});

		/* Определяем функцию показа */
        parentObject.dialogs.error.show = function (title, msg, onHide) {
            var self = this;
			// Если есть обработчик на закрытие, то добавляем его
            if (typeof (onHide) === 'function') {
                hideFunc = function () {
                    self.jDialog.off('dialogclose', hideFunc);
                    delete hideFunc;
                    hideFunc = null;
					onHide();
                };

                self.jDialog.on('dialogclose', hideFunc);
            };

			// Вставляем заголовок и текст окна
            self.jDialog.find('.custom-dialog-error-container-title').html(title ? title : 'Ошибка');
            self.jDialog.find('.custom-dialog-error-container-text').html(msg ? msg : 'Произошла неизвестная ошибка');

            self.jDialog.dialog('open');
        };

		/* Определяем функцию скрытия */
        parentObject.dialogs.error.hide = function () {
            var self = this;
            self.jDialog.dialog('close');
        };

		/* Определяем обработчик для кнопки Закрыть */
        parentObject.dialogs.error.jDialog.find('.custom-button-cancel').click(function () {
            parentObject.dialogs.error.hide();
        });

        ////////////////////////////////////////////////
        // Окно загрузки
        ////////////////////////////////////////////////

		/* Создаем окно загрузки */
        parentObject.dialogs.wait
        = parentObject.dialogs
            .form('custom-dialog-wait',
                '<div class="custom-dialog-wait-container">' +
                    '<div class="custom-dialog-wait-container-title">' +
                    '</div>' +
                    '<div class="custom-dialog-wait-container-text">' +
                        '<img src="images/ajax-loader.gif" />' +
                    '</div>' +
                '</div>',
                {
                    height: 100,
                    width: 300
                });

		/* Определяем функцию показа */
        parentObject.dialogs.wait.show = function (title, onHide) {
            var self = this;
			// Если есть обработчик на закрытие, то добавляем его
            if (typeof (onHide) === 'function') {
                hideFunc = function () {
                    self.jDialog.off('dialogclose', hideFunc);
                    delete hideFunc;
                    hideFunc = null;
					onHide();
                };

                self.jDialog.on('dialogclose', hideFunc);
            };

			// Вставляем заголовок окна
            self.jDialog.find('.custom-dialog-wait-container-title').html(title ? title : 'Подождите...');

            self.jDialog.dialog('open');
        };

		/* Определяем функцию скрытия */
        parentObject.dialogs.wait.hide = function () {
            var self = this;
            self.jDialog.dialog('close');
        };

        ////////////////////////////////////////////////
        // Окно с информацией
        ////////////////////////////////////////////////

		/* Создаем окно с информацией */
        parentObject.dialogs.info
        = parentObject.dialogs
            .form('custom-dialog-info',
                '<div class="custom-dialog-info-container">' +
                    '<div class="custom-dialog-info-container-title">' +
                    '</div>' +
                    '<div class="custom-dialog-info-container-text">' +
                    '</div>' +
                    '<div class="custom-dialog-info-container-btn-container">' +
                        '<button type="button" class="custom-button-cancel">Закрыть</button>' +
                    '</div>' +
                '</div>',
                {

                });

		/* Определяем функцию показа */
        parentObject.dialogs.info.show = function (title, msg, onHide) {
            var self = this;
			// Если есть обработчик на закрытие, то добавляем его
            if (typeof (onHide) === 'function') {
                hideFunc = function () {
                    self.jDialog.off('dialogclose', hideFunc);
                    delete hideFunc;
                    hideFunc = null;
					onHide();
                };

                self.jDialog.on('dialogclose', hideFunc);
            };

			// Вставляем заголовок и текст окна
            self.jDialog.find('.custom-dialog-info-container-title').html(title ? title : 'Информация');
            self.jDialog.find('.custom-dialog-info-container-text').html(msg ? msg : 'Операция успешно выполнена');

            self.jDialog.dialog('open');
        };

		/* Определяем функцию скрытия */
        parentObject.dialogs.info.hide = function () {
            var self = this;
            self.jDialog.dialog('close');
        };

		/* Определяем обработчик для кнопки Закрыть */
        parentObject.dialogs.info.jDialog.find('.custom-button-cancel').click(function () {
            parentObject.dialogs.info.hide();
        });

        ////////////////////////////////////////////////
        // Окно подтверждения
        ////////////////////////////////////////////////

		/* Создаем окно подтверждения */
        parentObject.dialogs.confirm
        = parentObject.dialogs
            .form('custom-dialog-confirm',
                '<div class="custom-dialog-confirm-container">' +
                    '<div class="custom-dialog-confirm-container-title">' +
                    '</div>' +
                    '<div class="custom-dialog-confirm-container-text">' +
                    '</div>' +
                    '<div class="custom-dialog-confirm-container-btn-container">' +
                        '<button type="button" class="custom-button-cancel">Отменить</button>' +
                        '<button type="button" class="custom-button-apply">Продолжить</button>' +
                    '</div>' +
                '</div>');

		/* Определяем функцию показа */
        parentObject.dialogs.confirm.show = function (title, msg, onHide, onApply) {
            var self = this;
			// Если есть обработчик на закрытие, то добавляем его
            if (typeof (onHide) === 'function') {
                hideFunc = function () {
                    self.jDialog.off('dialogclose', hideFunc);
                    delete hideFunc;
                    hideFunc = null;
					onHide();
                };

                self.jDialog.on('dialogclose', hideFunc);
            };

            // Удаляем предыдущий обработчик подтверждения
            self.jDialog.find('.custom-button-apply').unbind('click');
            self.jDialog.find('.custom-button-apply').click(function () {
                self.jDialog.dialog('close');
				// Если есть обработчик на подтверждение, то добавляем его
                if (typeof (onApply) === 'function')
                    onApply();
            });

			// Вставляем заголовок и текст окна
            self.jDialog.find('.custom-dialog-confirm-container-title').html(title ? title : 'Подтверждение');
            self.jDialog.find('.custom-dialog-confirm-container-text').html(msg ? msg : 'Вы действительно хотите выполнить данную операцию?');

            self.jDialog.dialog('open');
        };

		/* Определяем функцию скрытия */
        parentObject.dialogs.confirm.hide = function () {
            var self = this;
            self.jDialog.dialog('close');
        };

		/* Определяем обработчик для кнопки Отмена */
        parentObject.dialogs.confirm.jDialog.find('.custom-button-cancel').click(function () {
            parentObject.dialogs.confirm.hide();
        });
    });
})(window);