(function (pObj) {
	if (pObj.sjPoster)
        return;
	
    ////////////////////////////////////////////////
    // Создаем общий интерфейс для постера
    ////////////////////////////////////////////////
	pObj.sjPoster = {
	
		_settings: {
			groups: {},
			cats: {}
		},
	
		clearGroups: function () {
			this._settings.groups = {};
		},
	
		deleteGroup: function (id) {
			if (this._settings.groups[id + ''])
				delete this._settings.groups[id + ''];
		},
	
		updateGroup: function (id, name, interests) {
			var group = (this._settings.groups[id + ''] = this._settings.groups[id + ''] || {});
			
			if (name) group.name = name;
			if (interests instanceof Array) group.interests = interests;
			
			if (!group.interests)
				group.interests = [];
		},
	
		clearCats: function () {
			this._settings.cats = {};
		},
	
		deleteCat: function (id) {
			if (this._settings.cats[id + ''])
				delete this._settings.cats[id + ''];
		},
	
		updateCats: function (id, name, groups) {
			var cat = (this._settings.cats[id + ''] = this._settings.cats[id + ''] || {});
			
			if (name) cat.name = name;
			if (groups instanceof Array) cat.groups = groups;
			
			if(!cat.groups)
				cat.groups = [];
		},
	
		addCatGroup: function (id, groupid) {
			var cat = this._settings.cats[id + ''];

			if (cat) {
				for (var i = 0; i < cat.groups.length; i++) {
					if(cat.groups[i] + '' == groupid)
						return;
				}
				cat.groups.push(groupid);
			}
		},

		deleteCatGroup: function (id, groupid) {
			var cat = this._settings.cats[id + ''];

			if (cat) {
				for (var i = 0; i < cat.groups.length; i++) {
					if(cat.groups[i] + '' == groupid) {
						cat.groups.splice(i,1);
						return;
					}
				}
			}
		},
		
		loadSettings: function (handler) {
			var self = this;
			$.ajax('data.txt', {    
                contentType: "text/plain; charset=utf-8",
                dataType: 'json',
				async: false,
                success: function (result) {
					if (result)
						self._settings = result; //evalJSON
					if (typeof(handler) === 'function') {
						handler(result);
					}
                }
            });
		},
		
		// Создаем таб с текстом
		createTabText: function () {
			var tab = $('<div id="tabs-text" class="js-poster-tab">');
			tab.append('<span>Введите заголовок</span>').append('<br>').append('<br>')
			.append('<input type="text" class="js-poster-tab-input" >').append('<br>').append('<br>')
			.append('<span>Разместите html внутри следующей области</span>').append('<br>').append('<br>')
			.append('<textarea class="js-poster-tab-text-textarea" >').append('<br>').append('<br>')
			.append('<span>Как будет выглядеть html</span>').append('<br>').append('<br>')
			.append('<div class="js-poster-tab-text-result"></div>').append('<br>');
			
			$(tab).find('.js-poster-tab-text-textarea').change(function () {
				$(tab).find('.js-poster-tab-text-result').html($(this).val());
			});
			
			return tab;
		},
		
		// Создаем таб для парсинга
		createTabParse: function () {
			var tab = $('<div id="tabs-parse" class="js-poster-tab">'),
				self = this;
			tab
			.append('<span>Разместите html страницы внутри следующей области</span>').append('<br>').append('<br>')
			.append('<span class="js-poster-tab-comment">Если вы парсите с общего интерфейса "Написать в группы",' + 
					' а не c интерфейса группы, то перед копированием html необходимо выполнить магическую Js строку (вообще, html должен обновляться браузером, но...):</span>').append('<br>')
			.append('<span class="js-poster-tab-comment">$("#id_groups option:selected").attr("selected", "selected")</span>').append('<br>').append('<br>')
			.append('<textarea type="text" class="js-poster-tab-parse-textarea" >').append('<br>').append('<br>')
			.append('<span>А затем нажмите кнопку (как только парсинг закончится, текст из области исчезнет)</span>').append('<br>').append('<br>')
			.append('<button class="js-poster-tab-parse-button">Парсить</button>').append('<br>');
			
			tab.find('.js-poster-tab-parse-button').click(function () {
				var interests = [],
					htmlText = tab.find('.js-poster-tab-parse-textarea').val(),
					name = $(htmlText).find('#group_link').text(),
					id = $(htmlText).find('.subscriberu_fbbox').next().text()
					;
				$(htmlText).find('.write-place input').each(function () {
					interests.push({
						value: $(this).val(),
						name: $.trim($(this).parent().text().replace(/[\n\r]/g, ''))
					});
				});
				
				if ($(htmlText).find('#id_groups').length > 0) {
					id = $(htmlText).find('#id_groups').val();
					name = $(htmlText).find('#id_groups option:selected').text();
					
					$(htmlText).find('#id_interests option').each(function () {
						if($(this).val()) {
							interests.push({
								value: $(this).val(),
								name: $(this).text()
							});
						}
					});
				}
				
				if (!!id) self.updateGroup(id, name, interests);
				
				tab.find('.js-poster-tab-parse-textarea').val('');
			});
			
			return tab;
		},
		
		formTabSettings: function () {
			window.dialogs.wait.show();
			
			var tab = $('#tabs-settings'),
				self = this;
			
			tab.html('');
			
			tab
			.append('<span>Добавить категорию</span>').append('<br>').append('<br>')
			.append('<input type="text" class="js-poster-tab-input" >').append('<span>&nbsp;</span>')
			.append('<button class="js-poster-tab-settings-add-cat">Добавить</button>').append('<br>').append('<br>')
			.append('<span>Текущий набор и соответствие группам</span>').append('<br>').append('<br>')
			.append('<div class="js-poster-tab-settings-list"></div>').append('<br>').append('<br>')
			.append('<span>Сформировать JSON для сохранения</span>').append('<br>').append('<br>')
			.append('<button class="js-poster-tab-settings-form-json">Получить JSON для сохранения</button>').append('<br>').append('<br>')
			.append('<textarea class="js-poster-tab-settings-textarea" >').append('<br>').append('<br>')
			;	

			// Собираем и отображаем группы из списка по категориям
			var copyGroups = $.extend(true, {}, self._settings.groups),
				cats = self._settings.cats,
				divList = tab.find('.js-poster-tab-settings-list'),
				selectCats = $('<select class="js-poster-tab-settings-cats" >');
			
			// Формируем первый элемент без группы
			selectCats.append('<option value="">Без категории</option>');
			
			// Проходимся по всем категориям и наполняем список для переноса
			for(var counter in cats) {
				if (cats.hasOwnProperty(counter)) {
					selectCats.append('<option value="' + counter + '">' + cats[counter].name + '</option>');
				}
			}
			
			// Проходимся по всем категориям
			for(var counter in cats) {
				if (cats.hasOwnProperty(counter)) {
					divList.append('<hr/>')
					.append('<span class="js-poster-tab-settings-list-cat" data="' + counter + '">' + cats[counter].name + ' (' + cats[counter].groups.length + ')' + '</span>')
					.append('<button class="js-poster-tab-settings-list-cat-btn-del">Удалить</button>')
					.append('<br/>').append('<br/>');
					
					for(var gCnt = 0; gCnt < cats[counter].groups.length; gCnt++) {
						if (copyGroups[cats[counter].groups[gCnt] + '']) {
							var group = copyGroups[cats[counter].groups[gCnt] + ''],
								groupContainer = $('<div class="js-poster-tab-vibor-list-cat-group-container" >');
							
							divList.append(groupContainer);
							
							groupContainer.append('<span>&nbsp;</span>')
							.append('<span class="js-poster-tab-settings-list-cat-group" data="' + cats[counter].groups[gCnt] + '" currCat="' + counter + '">' + group.name + ' (' + cats[counter].groups[gCnt] + ')' + '</span>')
							.append('<button class="js-poster-tab-settings-list-btn-del">Удалить</button>')
							.append(selectCats.clone())
							.append('<button class="js-poster-tab-settings-list-btn">Перенести в </button>')
							.append('<br/>').append('<br/>');
						
							delete copyGroups[cats[counter].groups[gCnt] + ''];
						}
					}
				}
			}
			
			var nonCatCount = 0;
			
			// Отображаем группы без категории
			divList.append('<hr/>')
			.append('<span class="js-poster-tab-settings-list-cat" data="0">Без категории</span>').append('<br/>').append('<br/>');
			
			for(var cCounter in copyGroups) {
				var groupContainer = $('<div class="js-poster-tab-vibor-list-cat-group-container" >');
							
				divList.append(groupContainer);
				
				groupContainer.append('<span>&nbsp;</span>')
				.append('<span class="js-poster-tab-settings-list-cat-group" data="' + cCounter + '" currCat="0">' + copyGroups[cCounter + ''].name + ' (' + cCounter + ')' + '</span>')
				.append('<button class="js-poster-tab-settings-list-btn-del">Удалить</button>')
				.append(selectCats.clone())
				.append('<button class="js-poster-tab-settings-list-btn">Перенести в </button>')
				.append('<br/>').append('<br/>');
				nonCatCount++;
			}
			
			var lastCat = divList.find('.js-poster-tab-settings-list-cat:last');
			lastCat.text(lastCat.text() + ' (' + nonCatCount + ')');
			
			// Добавление категории
			tab.find('.js-poster-tab-settings-add-cat').click(function () {
				if(tab.find('.js-poster-tab-input').val()) {
					var catName = tab.find('.js-poster-tab-input').val(),
						date = new Date(),
						catId = date.getUTCFullYear() + '' + date.getMonth() + '' 
							+ date.getDate() + '' + date.getHours() + '' 
							+ date.getMinutes() + '' + date.getSeconds() + ''
							+ date.getMilliseconds();
							
					self.updateCats(catId, catName);
					self.formTabSettings();
				}
					
			});
			
			// Перенос группы
			tab.find('.js-poster-tab-settings-list-btn').click(function () {
				var catId = $(this).prev().val() + '',
					groupId = $(this).prev().prev().prev().attr('data') + '',
					currCat = $(this).prev().prev().prev().attr('currCat') + '';
				
				if(currCat != '0') 
					self.deleteCatGroup(currCat, groupId);
				self.addCatGroup(catId, groupId);
				self.formTabSettings();
			});

			// Удаление группы
			tab.find('.js-poster-tab-settings-list-btn-del').click(function () {
				var groupId = $(this).prev().attr('data') + '',
					currCat = $(this).prev().attr('currCat') + '';
				
				if(currCat != '0') 
					self.deleteCatGroup(currCat, groupId);
				self.deleteGroup(groupId);
				self.formTabSettings();
			});

			// Удаление категории
			tab.find('.js-poster-tab-settings-list-cat-btn-del').click(function () {
				var catId = $(this).prev().attr('data') + '';
				self.deleteCat(catId);
				self.formTabSettings();
			});
			
			// Формируем JSON для сохранения
			tab.find('.js-poster-tab-settings-form-json').click(function () {
				tab.find('.js-poster-tab-settings-textarea').val($.toJSON(self._settings));
			});
			
			window.dialogs.wait.hide();
		},
		
		createTabSettings: function () {
			var tab = $('<div id="tabs-settings" class="js-poster-tab">');
			return tab;		
		},

		
		// Создаем для группы список разделов
		createGroupInterestList: function (groupId) {
			var select = $('<select class="js-poster-tab-group-interests-list">'),
				group = this._settings.groups[groupId + ''];
			
			if (group) {
				for (var counter = 0; counter < group.interests.length; counter++) {
					select.append('<option value="' + group.interests[counter].value + '">' + group.interests[counter].name + '</option>');
				}
			}
			
			if (select.find('option').length == 0) {
				select.attr('disabled', 'disabled');
				select.addClass('disabled');
			}
			
			return select;
		},
		
		formTabVibor: function (tab) {
			var self = this;
			tab.html('');
			
			tab
			.append('<br>').append('<hr/>')
			.append('<button class="js-poster-tab-vibor-btn-refresh">Перезагрузить группы</button>').append('<br>')
			.append('<div class="js-poster-tab-vibor-list"></div>').append('<br>')
			;
			
			// Собираем и отображаем группы из списка по категориям
			var copyGroups = $.extend(true, {}, self._settings.groups),
				cats = self._settings.cats,
				divList = tab.find('.js-poster-tab-vibor-list'),
				catGroupsCounter;
			
			// Проходимся по всем категориям
			for(var counter in cats) {
				if (cats.hasOwnProperty(counter)) {
					var container = $('<div class="js-poster-tab-vibor-list-container">');
					divList.append(container);
					container.append('<hr/>')
					.append('<span class="js-poster-tab-vibor-list-cat" data="' + counter + '">' + cats[counter].name + ' (' + cats[counter].groups.length + ')' + '</span>')
					.append('<button class="js-poster-tab-vibor-list-cat-btn-del">Удалить</button>')
					.append('<br/>').append('<br/>');
					
					for(var gCnt = 0; gCnt < cats[counter].groups.length; gCnt++) {
						if (copyGroups[cats[counter].groups[gCnt] + '']) {
							var group = copyGroups[cats[counter].groups[gCnt] + ''],
								groupContainer = $('<div class="js-poster-tab-vibor-list-cat-group-container" >');
							
							container.append(groupContainer);
							
							groupContainer.append('<span>&nbsp;</span>')
							.append('<span class="js-poster-tab-vibor-list-cat-group" data="' + cats[counter].groups[gCnt] + '" currCat="' + counter + '">' + group.name + ' (' + cats[counter].groups[gCnt] + ')' + '</span>')
							.append('<button class="js-poster-tab-vibor-list-btn-del">Удалить</button>')
							.append(self.createGroupInterestList(cats[counter].groups[gCnt]))
							.append('<br/>').append('<br/>');
						
							delete copyGroups[cats[counter].groups[gCnt] + ''];
						}
					}
				}
			}
			
			var nonCatCount = 0;
			
			// Отображаем группы без категории
			var container = $('<div class="js-poster-tab-vibor-list-container">');
			divList.append(container);

			container.append('<hr/>')
			.append('<span class="js-poster-tab-vibor-list-cat" data="0">Без категории</span>')
			.append('<button class="js-poster-tab-vibor-list-cat-btn-del">Удалить</button>')
			.append('<br/>').append('<br/>');
			
			for(var cCounter in copyGroups) {
				var groupContainer = $('<div class="js-poster-tab-vibor-list-cat-group-container" >');
				container.append(groupContainer);
				
				groupContainer.append('<span>&nbsp;</span>')
				.append('<span class="js-poster-tab-vibor-list-cat-group" data="' + cCounter + '" currCat="0">' + copyGroups[cCounter + ''].name + ' (' + cCounter + ')' + '</span>')
				.append('<button class="js-poster-tab-vibor-list-btn-del">Удалить</button>')
				.append(self.createGroupInterestList(cCounter))
				.append('<br/>').append('<br/>');
				nonCatCount++;
			}
			
			var lastCat = divList.find('.js-poster-tab-vibor-list-cat:last');
			lastCat.text(lastCat.text() + ' (' + nonCatCount + ')');
			
			tab.find('.js-poster-tab-vibor-btn-refresh').click(function () {
				self.formTabVibor(tab);
			});
			
			// Удаление группы
			tab.find('.js-poster-tab-vibor-list-btn-del').click(function () {
				var countGroups = $(this).parent().parent().children('.js-poster-tab-vibor-list-cat-group-container').length - 1,
					catText = $(this).parent().parent().find('.js-poster-tab-vibor-list-cat').text();
				$(this).parent().parent().find('.js-poster-tab-vibor-list-cat').text(catText.replace(/\(\d+\)/g, '(' + countGroups + ')'));
				$(this).parent().remove();
			});

			// Удаление категории
			tab.find('.js-poster-tab-vibor-list-cat-btn-del').click(function () {
				$(this).parent().remove();
			});
			
		},
		
		createTabVibor: function () {
			var tab = $('<div id="tabs-vibor" class="js-poster-tab">');
			this.formTabVibor(tab);
			return tab;		
		},

		getRandomInt: function(min, max)
		{
			return Math.floor(Math.random() * (max - min + 1)) + min;
		},

		createFormAndSubmit: function (container, groupForSend, counterSend, onload) {
			var formContainer = $('<div class="js-poster-tab-start-list-container">'),
				groupId = groupForSend.find('.js-poster-tab-vibor-list-cat-group').attr('data'),
				iframeForSend = $('<iframe class="js-poster-tab-start-list-container-iframe" width="450" height="80" name="' + 'iframe_' + groupId + '" >'),
				formForSend = $('<form class="js-poster-tab-start-list-container-form" target="' + 'iframe_' + groupId + '" >'),
				btn = $('<button class="js-poster-tab-start-list-container-btn" >Результат нужный - удалить форму</button>'),
				interestId = groupForSend.find('.js-poster-tab-group-interests-list').val(),
				header = $.trim($('#tabs-text').find('input.js-poster-tab-input').val()),
				body = $.trim($('#tabs-text').find('.js-poster-tab-text-textarea').val()),
				info = $('<div class="js-poster-tab-start-list-container-info">'),
				self = this;
			container.append(formContainer);
			formContainer
			.append('<hr/>')
			.append(formForSend)
			.append(info)
			.append(btn)
			.append('<br/>').append('<br/>').append('<br/>').append('<br/>')
			.append(iframeForSend)
			;
			
			// Заполним info
			info
			.append('<span>Техническая информация запуска #(' + (counterSend + 1) + '): </span>')
			.append('<br/>')
			.append('<span>Группа: </span>')
			.append('<span>' + groupForSend.find('.js-poster-tab-vibor-list-cat-group').text() + '</span>')
			.append('<br/>')
			.append('<span>Раздел: </span>')
			.append('<span>' + groupForSend.find('.js-poster-tab-group-interests-list option:selected').text() + '</span>')
			.append('<br/>')
			.append('<span>Раздел (ID): </span>')
			.append('<span>' + groupForSend.find('.js-poster-tab-group-interests-list option:selected').val() + '</span>')
			;
			
			// Заполняем iframe
			iframeForSend[0].onload = function () { iframeForSend[0].onload = null; onload(); };
			
			// Заполняем форму и отправляем
			formForSend[0].method = 'post';
			formForSend[0].action = 'http://subscribe.ru/member/group/write/?random=' + (new Date()).getUTCMilliseconds() + '' + self.getRandomInt(1, 60000);
			formForSend.append('<input name="groups" type="hidden" value="' + groupId + '" />');
			formForSend.append('<input name="interests" type="hidden" value="' + interestId + '" />');
			formForSend.append('<input name="subject" type="hidden" value="" />');
			formForSend.find('input[name="subject"]').val(header);
			formForSend.append('<input name="body" type="hidden" value="" />');
			formForSend.find('input[name="body"]').val(body);
			formForSend.append('<input type="submit" value="Отправить еще раз" />');
			
			btn.click(function () {
				btn.parent().remove();
			});
			
			formForSend.submit();
		},
		
		createTabStart: function () {
			var tab = $('<div id="tabs-start" class="js-poster-tab">'),
				self = this;

			tab
			.append('<br>')
			.append('<hr/>')
			.append('<button class="js-poster-tab-start-btn">Запустить отправку анонсов и статей на Subscribe</button>')
			.append('<hr/>')
			.append('<br>')
			.append('<div class="js-poster-tab-start-list"></div>')
			.append('<br>')
			;
			
			tab.find('.js-poster-tab-start-btn').click(function () {
				var errorMsg = '';
					
				if ($('#tabs-vibor').find('.js-poster-tab-vibor-list-cat-group-container').length == 0) {
					errorMsg += '<font color=red>* Не выбраны группы для анонсирования</font>'
						+ '<br/>'
						+ 'Перейдите на вкладку "Выбор групп для постинга" <br/> и выберите группы для постинга'
						+ '<br/>';
				}
				if ($.trim($('#tabs-text').find('input.js-poster-tab-input').val()) == '') {
					errorMsg += '<font color=red>* Не указан заголовок</font>'
						+ '<br/>'
						+ 'Перейдите на вкладку "Текст анонса и заголовок" <br/> и укажите заголовок'
						+ '<br/>';
				}
				if ($.trim($('#tabs-text').find('.js-poster-tab-text-textarea').val()) == '') {
					errorMsg += '<font color=red>* Не указан анонс</font>'
						+ '<br/>'
						+ 'Перейдите на вкладку "Текст анонса и заголовок" <br/> и укажите анонс'
						+ '<br/>';
				}
				
				if (errorMsg !== '') {
					window.dialogs.error.show('Исправьте ошибки', errorMsg);
					return;
				}
				
				window.dialogs.wait.show();
				
				var groupForSend = $('#tabs-vibor').find('.js-poster-tab-vibor-list-cat-group-container'),
					groupForSendLength = groupForSend.length,
					container = tab.find(".js-poster-tab-start-list"),
					recursionFunction = function (counter, handler) {
						// Защита от запуска с конца
						if (counter >= groupForSendLength) {
							if (typeof(handler) === 'function')
								handler();
							return;
						}

						// Если тукущий элемент не последний, то запускаем следующую итерацию
						if (counter < groupForSendLength - 1) {
							self.createFormAndSubmit(container, $(groupForSend[counter]), counter, function () {
								setTimeout(function () {
										recursionFunction(counter + 1, handler);
									}, 
								self.getRandomInt(15000, 45000));
							});
						}
						else {
							self.createFormAndSubmit(container, $(groupForSend[counter]), counter);
							if (typeof(handler) === 'function')
								handler();
						}
					};
				
				recursionFunction(0, function () { window.dialogs.wait.hide(); window.dialogs.info.show('Выполнение операции', 'Постинг завершен!'); });
			});
			
			return tab;		
		},
		
		createInterface: function (container) {
			var header = $('<h1>Автоматическая публикация анонсов в Subscribe (sjPoster)</h1>'),
				tabsContainer = $('<div class="js-poster-tabs">'),
				ulTabs = $('<ul class="js-poster-tabs-ul">'),
				self = this;
				
			$(container).append(header).append(tabsContainer);
			tabsContainer.append(ulTabs);
			// Создаем вкладку с текстом и заголовком
			ulTabs.append('<li><a href="#tabs-text">Текст анонса и заголовок</a></li>');
			tabsContainer.append(this.createTabText());
			
			// Создаем вкладку для парсинга данных
			ulTabs.append('<li><a href="#tabs-parse">Парсинг данных</a></li>');
			tabsContainer.append(this.createTabParse());

			// Создаем вкладку с настройками групп
			ulTabs.append('<li><a href="#tabs-settings">Настройки групп</a></li>');
			tabsContainer.append(this.createTabSettings());

			// Создаем вкладку для запуск процесса
			ulTabs.append('<li><a href="#tabs-vibor">Выбор групп для постинга</a></li>');
			tabsContainer.append(this.createTabVibor());

			// Создаем вкладку для запуск процесса
			ulTabs.append('<li><a href="#tabs-start">Запуск постинга</a></li>');
			tabsContainer.append(this.createTabStart());
			
			// Создаем вкладки
			$(tabsContainer).tabs({
				beforeActivate: function( event, ui ) {
					if(ui.newPanel.is('#tabs-settings')) {
						self.formTabSettings();
					}
				}
			});
		},
		
		init: function (container) {
			window.dialogs.wait.show();

			// Загружаем настройки
			this.loadSettings();
			
			// Формируем инструмент
			this.createInterface(container);
			
			window.dialogs.wait.hide();
		}
	};
	
})(window);

function jsonpCallback(data) {
	alert(data);
}

$(function () {
	window.sjPoster.init('.sj-poster-container');
});